var LOGFILE_NAME = "sonos-controller.log";
var lWarn = {
		logln : function(o) {
		}
	};
	var lInfo = {
		logln : function(o) {
		}
	};

lInfo = new Logger(LOGFILE_NAME);
lWarn = new Logger(LOGFILE_NAME);


function convertOldEntries() {
	return upgradePlayerConnection();
}

function upgradePlayerConnection() {
	var oPlayerIPs=[];
	if (Property.getNode('sonos-players')!=null)
		if (Property.getNode('sonos-players').getChildren()) {
			var oArray=Property.getNode('sonos-players').getChildren();
			for (var iIndex=0;iIndex<oArray.length;iIndex++) {
				if (oArray[iIndex].getChild('ipAddress')!=null)
					oPlayerIPs.push(oArray[iIndex].getChild('ipAddress').getValue());				
			}
			new Event('sonos.player',{actions:'updatePlayerDirect',referenceIPs:JSON.stringify(oPlayerIPs),concurrenceEvent:'sonos.update',concurrenceEventParameter:'{"actions":"backwartUpdateStep2"}'}).raise();
			return true;
		}
	return false;
}

function encodeMetaData(metaData) {	
	metaData=metaData.replace(/&/g, '&amp;');
	metaData=metaData.replace(/</g, '&lt;');
	metaData=metaData.replace(/>/g, '&gt;');
	metaData=metaData.replace(/"/g, '&quot;');
	metaData=metaData.replace(/'/g, '&apos;');
	return metaData;
}

function updateZoneConnection() {
	if (Property.getNode('sonos-players')!=null)
		if (Property.getNode('sonos-players').getChildren()) {
			var oArray=Property.getNode('sonos-players').getChildren();
			for (var iIndex=0;iIndex<oArray.length;iIndex++) {
				var id=oArray[iIndex].getChild('deviceID').getValue();
				var ip=parseInt("" + oArray[iIndex].getChild('roomID').getValue(),10);
				if (ip!=0)
					new Event('sonos.player',{actions:'setZone',id:id,zoneID:ip}).raise();
				if (oArray[iIndex].getChild('disabled').getValue()=='true') {
					new Event('sonos.player',{actions:'disable',id:id}).raise();
				}
			}
		}
}

function updateEntry(path,fPreset) {
	lInfo.logln('start ' + path);
	var oParameterObject={triggers:[],target:{},action:{},conditions:{}};
	var oBaseNode=Property.getNode(path);
	
	oParameterObject.action.restoreAfter=!fPreset;
	lInfo.logln('actiontype ');
	if (oBaseNode.getChild('actionType')!=null) {
		switch(oBaseNode.getChild('actionType').getValue()) {
			case 0:
				if (oBaseNode.getChild('nowSingleUrl')!=null) {
					var fRadio=false;
					if (oBaseNode.getChild('nowSingeIsRadio')!=null)
						if ('' + oBaseNode.getChild('nowSingeIsRadio').getValue()=='true')
							fRadio=true;
					if (oBaseNode.getChild('nowSingleUrl').getValue().indexOf('x-sonosapi-stream')>=0)
						fRadio=true;
					if (fRadio) {
						oParameterObject.action.type='plainRadio';
						oParameterObject.action.contentSrc=oBaseNode.getChild('nowSingleUrl').getValue();
						oParameterObject.action.restoreAfter=false;
						oParameterObject.action.info={
								title:oBaseNode.getChild('nowSingleTitle').getValue()
							};
					} else {
						oParameterObject.action.type='plainSong';
						oParameterObject.action.contentSrc=oBaseNode.getChild('nowSingleUrl').getValue();
						oParameterObject.action.info={
							title:oBaseNode.getChild('nowSingleTitle').getValue(),
							artist:oBaseNode.getChild('nowSingleArtist').getValue()
						};
					}
				} else
				if (oBaseNode.getChild('active-queue') != null){
					oParameterObject.action.type='plainQueue';
					oParameterObject.action.content=[];
					var oQueue=oBaseNode.getChild('active-queue').getChildren();
					for (var iIndex=0;iIndex<oQueue.length;iIndex++) {
						var oObject={
							contentUrl:oQueue[iIndex].getChild('playID').getValue(),
							title:oQueue[iIndex].getChild('title').getValue(),
							pos:oQueue[iIndex].getChild('trackPos').getValue()
						}
						oParameterObject.action.content.push(oObject);
					}
					
				}
					
			break;
			case 1: 
				// playlists
				if (oBaseNode.getChild('playListURL') != null) {
					oParameterObject.action.type='playlist';
					oParameterObject.action.contentSrc=oBaseNode.getChild('playListURL').getValue();
				} else 
				if (oBaseNode.getChild('active-queue') != null){
					oParameterObject.action.type='plainQueue';
					oParameterObject.action.content=[];
					var oQueue=oBaseNode.getChild('active-queue').getChildren();
					for (var iIndex=0;iIndex<oQueue.length;iIndex++) {
						var oObject={
							contentUrl:oQueue[iIndex].getChild('playID').getValue(),
							title:oQueue[iIndex].getChild('title').getValue(),
							pos:oQueue[iIndex].getChild('trackPos').getValue()
						}
						oParameterObject.action.content.push(oObject);
					}
					
				}
			break;
			case 2:
				// favorite
				oParameterObject.action.type='favorite';
				lInfo.logln(oBaseNode.getChild('favoritesURL').getValue());
				oParameterObject.action.contentSrc=oBaseNode.getChild('favoritesURL').getValue();
				oParameterObject.action.metaData=encodeMetaData(escape(oBaseNode.getChild('metaData').getValue()));
			break;
			case 3:
				// library
				oParameterObject.action.type='library';
				oParameterObject.action.contentSrc=oBaseNode.getChild('nowSingleUrl').getValue();
				oParameterObject.action.guid=oBaseNode.getChild('mediaFileGUID').getValue();
			break;
			case 4:
				// t2speech
				oParameterObject.action.type='text2speech';
				oParameterObject.action.contentSrc=oBaseNode.getChild('nowSingleUrl').getValue();
				oParameterObject.action.guid=oBaseNode.getChild('t2Sguid').getValue();
				oParameterObject.action.text=oBaseNode.getChild('t2Stext').getValue();
				oParameterObject.action.voice_id=oBaseNode.getChild('t2SvoiceID').getValue();
			break;
			case 5:
				//commands 
				oParameterObject.action.type='command';
				switch (parseInt('' + oBaseNode.getChild('command').getValue(),10)) {
					case 1:
						oParameterObject.action.command='stop';
					break;
					case 2:
						oParameterObject.action.command='play';
					break;
					case 3:
						oParameterObject.action.command='pause';
					break;
					case 4:
						oParameterObject.action.command='mute';
					break;
					case 5:
						oParameterObject.action.command='unmute';
					break;
					case 6:
						lInfo.logln('volume up not supported');
						return;
					break;
					case 7:
						lInfo.logln('volume up not supported');
						return;
					break;
				}
			break;
			default:
				lInfo.logln("can't convert " + oBaseNode.getPath());
			break;
		}
	}
	lInfo.logln('volume');
	
	if (oBaseNode.getChild('volumeSet')!=null) {
		if ("" + oBaseNode.getChild('volumeSet').getValue()=='true')
			if (oBaseNode.getChild('volume')!=null) {
				oParameterObject.action.volume=parseInt(''+ oBaseNode.getChild('volume').getValue(),10);
			}	
	}

	if (oBaseNode.getChild('setRepeat')!=null) {
		if ("" + oBaseNode.getChild('setRepeat').getValue()=='true')
			if (oBaseNode.getChild('repeatTime')!=null) {
				oParameterObject.action.loopingTimespan=parseInt('' + oBaseNode.getChild('repeatTime').getValue(),10) * 60;
			}	
	}

	if (oBaseNode.getChild('restartAfter')!=null) {
		if ("" + oBaseNode.getChild('restartAfter').getValue()=='true')
			oParameterObject.action.restartAfter=true;
	}
	// restart after
	// restore after
	
	lInfo.logln('target');
	if ((oBaseNode.getChild('allRooms')!=null) && (oBaseNode.getChild('allRooms').getValue()==1)) {
		if (oBaseNode.getChild('createSonosGroup').getValue()=="true")
			oParameterObject.target.grouped=[0];
		else
			oParameterObject.target.singularyZone=[0];
	} else {
		if (oBaseNode.getChild('roomID')!=null)
			oParameterObject.target.singularyZone=[oBaseNode.getChild('roomID').getValue()];
		else {
			if (oBaseNode.getChild('pickedRooms')!=null) {
				var sPickedRooms=oBaseNode.getChild('pickedRooms').getValue();
				var oPickedRooms=sPickedRooms.split(';');
				var aPickedRooms=[];
				for (var iIndex=0;iIndex<oPickedRooms.length;iIndex++)
					aPickedRooms.push(parseInt(oPickedRooms[iIndex],10));
				if (oBaseNode.getChild('createSonosGroup').getValue()=="true")
					oParameterObject.target.grouped=aPickedRooms;
				else
					oParameterObject.target.singularyZone=aPickedRooms;
				
			}
		}
			
	}
			
	lInfo.logln('trigger');
	
	var oBaseTriggers=oBaseNode.getChild('triggers').getChildren();
	for (var iIndex=0;iIndex<oBaseTriggers.length;iIndex++) {
		var oObject={};
		var oTriggerNodeArray=oBaseTriggers[iIndex].getChildren();
		for (var jIndex=0;jIndex<oTriggerNodeArray.length;jIndex++)
			oObject[oTriggerNodeArray[jIndex].getName()]=oTriggerNodeArray[jIndex].getValue();
		oParameterObject.triggers.push(oObject);
	}
	
	lInfo.logln('condies enabled' + oBaseNode.getChild('conditions/enabled').getValue());
	lInfo.logln('condies disabled prop' + oBaseNode.getChild('disabled').getValue());
	oParameterObject.conditions.enabled=true;
	if (oBaseNode.getChild('disabled')!=null)
		oParameterObject.conditions.enabled=(""+oBaseNode.getChild('disabled').getValue()!='true');
	else
		if (oBaseNode.getChild('conditions/enabled').getValue()) 
			oParameterObject.conditions.enabled=true;
		else
			oParameterObject.conditions.enabled=false;
	lInfo.logln('PATH : ' + path + '\n' + JSON.stringify(oParameterObject));
	new Event('sonos.config',{actions:'save',value:JSON.stringify(oParameterObject)}).raise();
	
}

function updateSonosActivities() {
	lInfo.logln('updateSonosActivities');
	if (Property.getNode('sonos-activities')!=null)
		if (Property.getNode('sonos-activities').getChildren()!=null) { 
			var oArray=Property.getNode('sonos-activities').getChildren();
			for (var iIndex=0;iIndex<oArray.length;iIndex++) {
				var fSkip=false;
				lInfo.logln('update ' + oArray[iIndex].getPath());
				if (oArray[iIndex].getChild('predefined')!=null)
					if (oArray[iIndex].getChild('predefined').getValue()=='true')
						fSkip=true;
				if (!fSkip)
					updateEntry(oArray[iIndex].getPath(),false);
				else
					lInfo.logln('skipping, because it predefined');
			}
		}	
}

function updateSonosPresets() {
	lInfo.logln('updateSonosPresets');
	if (Property.getNode('sonos-presets')!=null)
		if (Property.getNode('sonos-presets').getChildren()!=null) {
			var oArray=Property.getNode('sonos-presets').getChildren();
			for (var iIndex=0;iIndex<oArray.length;iIndex++) {
				var fSkip=false;
				lInfo.logln('update ' + oArray[iIndex].getPath());
				if (oArray[iIndex].getChild('predefined')!=null)
					if (oArray[iIndex].getChild('predefined').getValue()=='true')
						fSkip=true;
				if (oArray[iIndex].getChild('predefined')!=null)
					if (oArray[iIndex].getChild('predefined').getValue()==true)
						fSkip=true;
				if (!fSkip)
					updateEntry(oArray[iIndex].getPath(),true);
				else
					lInfo.logln('skipping, because it predefined');
			}
		}
}

function cleanUp() {
	lInfo.logln('deleteing the old schmackes');
	var baseNode=Property.getNode('/scripts/sonos-controller');
	var fStore=false;
	if (baseNode.getChild('sonos-presets')!=null) {
		baseNode.removeChild('sonos-presets');
		fStore=true;
	}
	if (baseNode.getChild('sonos-players')!=null) {
		baseNode.removeChild('sonos-players');
		fStore=true;
	}
	if (baseNode.getChild('sonos-selected-preset')!=null) {
		baseNode.removeChild('sonos-selected-preset');
		fStore=true;
	}
	if (baseNode.getChild('sonos-predifined')!=null) {
		baseNode.removeChild('sonos-predifined');
		fStore=true;
	}
	if (baseNode.getChild('sonos-activities')!=null) {
		baseNode.removeChild('sonos-activities');
		fStore=true;
	}
	if (fStore)
		Property.store();
}

function updatePresets() {
	var fStore=false;
	if (Property.getNode('entries')==null)
		return;
	var oArray=Property.getNode('entries').getChildren();
	for (var iIndex=0;iIndex<oArray.length;iIndex++) {
		var oEntryNode=oArray[iIndex];
		lInfo.logln('checking node' + oEntryNode.getPath());
		if (oEntryNode.getChild('triggers')!=null) {
			var oTriggerArray=oEntryNode.getChild('triggers').getChildren();
			for (var jIndex=0;jIndex<oTriggerArray.length;jIndex++) {
				lInfo.logln('checking trigger' + oTriggerArray[jIndex].getPath());
				if (oTriggerArray[jIndex].getChild('type').getValue()=='bus-zone-scene') {
					if (oTriggerArray[jIndex].getChild('scene').getValue()==5) {
						Property.setProperty(oTriggerArray[jIndex].getChild('type').getPath(),'zone-scene');
						fStore=true;
					}
					if (oTriggerArray[jIndex].getChild('scene').getValue()==17) {
						Property.setProperty(oTriggerArray[jIndex].getChild('type').getPath(),'zone-scene');
						fStore=true;
					}
					if (oTriggerArray[jIndex].getChild('scene').getValue()==18) {
						Property.setProperty(oTriggerArray[jIndex].getChild('type').getPath(),'zone-scene');
						fStore=true;
					}
					if (oTriggerArray[jIndex].getChild('scene').getValue()==19) {
						Property.setProperty(oTriggerArray[jIndex].getChild('type').getPath(),'zone-scene');
						fStore=true;
					}
				}
			}
		}
	}
	if (fStore)
		Property.store();
}

if (raisedEvent.parameter.actions!=null) {
	if (raisedEvent.parameter.actions=='backwartUpdateStep2') {
		updateZoneConnection();
		new Event('sonos.config',{actions:'ensurePredefinedEntries'}).raise();
		new Event('sonos.cloud',{actions:'startup'}).raise();
		new Event('sonos.info',{actions:'fetchSonosPlaylists'}).raise();
		new Event('sonos.info',{actions:'fetchSonosFavorites'}).raise();
		new Event('sonos.player',{actions:'updateZoneConnectedDevices'}).raise();
		new Event('sonos.update',{actions:'updateEntries'}).raise();
	}
	if (raisedEvent.parameter.actions=='startup') {
		Property.load();
		if (!convertOldEntries()) {
			new Event('sonos.config',{actions:'ensurePredefinedEntries'}).raise();
			new Event('sonos.cloud',{actions:'startup'}).raise();
			new Event('sonos.info',{actions:'fetchSonosPlaylists'}).raise();
			new Event('sonos.info',{actions:'fetchSonosFavorites'}).raise();
			new Event('sonos.player',{actions:'updateZoneConnectedDevices'}).raise();
		}
		updatePresets();		
	}
	if (raisedEvent.parameter.actions=='mainteance') {
		new Event('sonos.info',{actions:'fetchSonosPlaylists'}).raise();
		new Event('sonos.info',{actions:'fetchSonosFavorites'}).raise();
		new Event('sonos.cloud',{actions:'startMultilanguageSpeechLibrary'}).raise();
	}
	if (raisedEvent.parameter.actions=='updateEntries') {
		updateSonosActivities();
		updateSonosPresets();
		cleanUp();
	}
}

