Ext.define('DSS.addon.PresetActionSelector', {
	extend : 'DSS.component.Base',
	mixins : {
		observable : 'Ext.util.Observable'
	},
	getHeight : function() {
		return this.iDefaultHeight;
	},

	height : '100%',
	grids : {},
	nowFileType : -1, // -1: nothing, 0: current music, 1:
	// current queue
	parentDialog : '',
	rowVolume : null,
	checkVolume : null,
	intVolume : null,
	lblNowPlayed : null,
	selectedSong : null,
	selectedQueue : null,
	gridQueue : null,
	macPanel : null,
	arrayActiveRooms : null,
	iDefaultWidth : 150,
	iDefaultHeight : 290,
	nActionType : -1,
	bIsRadio : false,
	arrayMediaLibrary : null,
	arraySpeechSettings : null,
	mediaGroupsSub : null,
	value : null,
	checkIfSelectedItemIsSingleFile : function(bTestText2SpeechParams) {
		var returnInfo = {
			bValidSelection : false,
			bSingleFileSelected : false
		};

		var oSelectionLVL1 = this.grids.lvl1.getSelectionModel().getSelection();
		if (oSelectionLVL1[0] != null) {
			switch (oSelectionLVL1[0].get('_id')) {
			case 0:
				if (this.nowFileType == 0 && this.selectedSong != null) {
					returnInfo.bValidSelection = true;
					returnInfo.bSingleFileSelected = true;
					if (this.selectedSong.isRadio != null)
						returnInfo.bSingleFileSelected = !this.selectedSong.isRadio;
				} else if (this.nowFileType == 1 && this.selectedQueue != null)
					returnInfo.bValidSelection = true;
				break;

			case 1: // playlists
				oSelectionPlaylist = this.grids.lvlPlaylist.getSelectionModel().getSelection();
				if (oSelectionPlaylist != null && oSelectionPlaylist.length > 0) {
					returnInfo.bValidSelection = true;
				}
				break;

			case 2: // favorites
				oSelectionFavorites = this.grids.lvlFavorites.getSelectionModel().getSelection();
				if (oSelectionFavorites != null && oSelectionFavorites.length > 0) {
					returnInfo.bValidSelection = true;
					// check if single file
				}
				break;

			}
		}

		return returnInfo;
	},
	defMacGridRenderer : function(val, metadata, record, colIdx, store, view) {
		var fIsPassive = false;
		if (record.get('passive') != null)
			if (record.get('passive'))
				fIsPassive = true;
		var fHasNext = false;
		if (record.get('next') == true) {
			fHasNext = true;
		}
		var sReturn = '<table style="height:16px;"><tr>';
		var iColspaceCounter = 3;
		if (fIsPassive) {
			sReturn += '<td style="color:#888888;" colspan="' + iColspaceCounter + '" width="100%">' + record.get('name') + '</td>';
		} else {
			sReturn += '<td colspan="' + iColspaceCounter + '" width="100%">' + record.get('name') + '</td>';
		}
		if (fHasNext) {
			sReturn += '<td>&gt;</td>';
		}
		return sReturn + '</tr></table>';
	},
	initLvl1 : function() {
		if (Ext.data.StoreManager.lookup('presetAction_lvl1') == null) {
			var actions = [ {
				name : _('Now Playing'),
				_id : 0,
				next : true,
				icon : null,
				passive : false
			}, {
				name : _('Sonos Playlist'),
				_id : 1,
				next : true,
				icon : null,
				passive : false
			}, {
				name : _('Sonos Favorites'),
				_id : 2,
				next : true,
				icon : null,
				passive : false
			} ];

			Ext.create('Ext.data.Store', {
				storeId : 'presetAction_lvl1',
				fields : [ '_id', 'name', 'next', 'icon', 'passive' ],
				proxy : {
					type : 'memory',
					reader : {
						type : 'json',
						root : 'items'
					}
				}
			});
			Ext.data.StoreManager.lookup('presetAction_lvl1').add(actions);
		}
	},
	initStores : function() {
		try {

			var me = this;

			this.arrayActiveRooms = [];
			var arrayPlayRooms = [];

			for ( var sKey in result.result) {
				var roomID = parseInt("" + result.result[sKey].roomID, 10);
				var notDiscovered = (result.result[sKey].notDiscovered != 'false');
				var disabled = (result.result[sKey].disabled != 'false');
				if (roomID > 0)
					if (!notDiscovered)
						if (!disabled) {
							this.arrayActiveRooms.push(result.result[sKey]);
							var tmpData = new Object({
								'_id' : roomID,
								'name' : dss.staticDataModel.getNameForZone(roomID),
								'next' : true,
								'passive' : false
							});
							arrayPlayRooms.push(tmpData);
						}
			}

			Ext.create('Ext.data.Store', {
				storeId : 'whattoplay_queue',
				fields : [ '_id', 'name', 'next', 'icon', 'passive' ],
				proxy : {
					type : 'memory',
					reader : {
						type : 'json',
						root : 'items'
					}
				}
			});
		} catch (e) {
			// alert("WtP initCache "+e.message);
		}
	},
	fillMediaFilesGrid : function(id, lvl) {
		var store;
		var baseArray;
		if (id == null) {

			if (Ext.data.StoreManager.lookup('presetAction_mediafiles_base') == null) {
				Ext.create('Ext.data.Store', {
					storeId : 'presetAction_mediafiles_base',
					fields : [ '_id', 'name', 'next', 'icon', 'passive', 'lvl' ],
					proxy : {
						type : 'memory',
						reader : {
							type : 'json',
							root : 'items'
						}
					},
					sorters : [ {
						property : 'name',
						direction : 'ASC'
					} ]
				});
			} else
				Ext.data.StoreManager.lookup('presetAction_mediafiles_base').removeAll();

			store = Ext.data.StoreManager.lookup('presetAction_mediafiles_base');
			baseArray = mediaLibrary;
			lvl = 1;
		} else {
			if (Ext.data.StoreManager.lookup('presetAction_mediafiles_' + lvl) == null) {
				Ext.create('Ext.data.Store', {
					storeId : 'presetAction_mediafiles_' + lvl,
					fields : [ '_id', 'name', 'next', 'icon', 'passive', 'lvl' ],
					proxy : {
						type : 'memory',
						reader : {
							type : 'json',
							root : 'items'
						}
					},
					sorters : [ {
						property : 'name',
						direction : 'ASC'
					} ]
				});
			} else
				Ext.data.StoreManager.lookup('presetAction_mediafiles_' + lvl).removeAll();

			store = Ext.data.StoreManager.lookup('presetAction_mediafiles_' + lvl);
			var oRecSearch = function(oObject, id) {
				if (oObject.id == id)
					return oObject;
				if (oObject.child != null)
					for (var iIndex = 0; iIndex < oObject.child.length; iIndex++) {
						var oRet = oRecSearch(oObject.child[iIndex], id);
						if (oRet != null)
							return oRet;
					}

			}
			baseArray = oRecSearch(mediaLibrary, id);
		}
		store.removeAll();

		for (var iIndex = 0; iIndex < baseArray.child.length; iIndex++) {
			store.add({
				'_id' : baseArray.child[iIndex].id,
				'name' : baseArray.child[iIndex].name,
				'next' : true,
				'passive' : false,
				'lvl' : lvl
			});
		}
		for (var iIndex = 0; iIndex < baseArray.files.length; iIndex++) {
			store.add({
				'_id' : baseArray.files[iIndex].id,
				'name' : baseArray.files[iIndex].name,
				'next' : false,
				'passive' : false,
				'lvl' : lvl
			});
		}
	},
	updatePresetName : function(sNewName) {
		if (sNewName != "") {
			this.dssEditor.editControls.audioName.setValue(sNewName);
		}
	},
	getSonosDeviceMusic : function(selectedRoom) {
		var me = this;
		if (this.getDeviceMusicCallback==null) {
			this.getDeviceMusicCallback=function(oValue) {
				if (oValue.actions!='getCurrentTitle')
					return;

				var sTitle = _("No music");
				var bWarnOnlySong = false;
				me.selectedSong = null;
				if (oValue.value != null) {
					if (oValue.value == 'error') {
						waitDialog.hide();
						Ext.MessageBox.alert(_('Info'), _("Assigned Sonos Speaker is currently not available."), null);
						return true;
					}
					var selectedValue = JSON.parse(unescape(oValue.value));
					me.selectedSong = selectedValue
					
					if (me.selectedSong.url != null)
						if (me.selectedSong.url != "") {
							if (me.selectedSong.isRadio) {
								// is a stream
								sTitle = _("Radio: ");
								for (var iIndex=0;iIndex<playerStore.getCount();iIndex++) {
									var oRecord=playerStore.getAt(iIndex);
									var sString='x-rincon-stream:' + oRecord.get('id')
									if (sString==me.selectedSong.url)
										sTitle = _("Audio Component: ") + oRecord.get('deviceName');
								}
							}									
							else
								sTitle = _("Song: ");

							me.bIsRadio = me.selectedSong.isRadio;
							if (me.selectedSong.title != null)
								if (me.selectedSong.title != "")
									sTitle += me.selectedSong.title;
							if (me.selectedSong.artist != null)
								if (me.selectedSong.artist != "")
									sTitle += " (" + me.selectedSong.artist + ")";
							me.selectedSong.changed = true;

							me.updatePresetName(me.selectedSong.title);
						}
				}
				me.lblNowPlayed.setText(sTitle);

				me.nowFileType = 0;

				waitDialog.hide();
				if (bWarnOnlySong)
					Ext.MessageBox.alert(_('Info'), _("Only music with defined length allowed"), null);
				return true;
			};
			fChangedCallback.push(this.getDeviceMusicCallback);
		}
		
		
		me.gridQueue.setVisible(false);
		me.lblNowPlayed.setVisible(true);

		if (selectedRoom > -1) {
			var waitDialog = new Ext.LoadMask(Ext.getBody(), {
				msg : _('Please wait, reading from Sonos device ...')
			});
			waitDialog.show();
			dss.raiseEvent('sonos.info',{
				actions : 'getCurrentTitle',
				zoneID : selectedRoom
			});
			
		}
	},
	getSonosDeviceQueue : function(selectedRoom) {
		var me = this;

		me.gridQueue.setVisible(false);
		me.lblNowPlayed.setVisible(false);
		if (this.getDeviceQueueCallback==null) {
			this.getDeviceQueueCallback=function (oValue) {
				if (oValue.actions!='getCurrentQueue')
					return;
				if (oValue.value != null) {
					if (oValue.value == 'error') {
						waitDialog.hide();
						Ext.MessageBox.alert(_('Info'), _("Assigned Sonos Speaker is currently not available."), null);
						return true;
					}
					me.selectedQueue = JSON.parse(unescape(oValue.value));
					if (me.selectedQueue != null) {
						Ext.data.StoreManager.lookup('whattoplay_queue').removeAll();

						if (me.selectedQueue.length > 0) {
							var arrayFiles = new Array();
							for (var iIndex = 0; iIndex < me.selectedQueue.length; iIndex++) {
								var pos = (iIndex + 1);
								var tmpObj = new Object({
									_id : iIndex,
									name : pos + ". " + unescape(me.selectedQueue[iIndex].title)
								});
								arrayFiles.push(tmpObj);
							}
							Ext.data.StoreManager.lookup('whattoplay_queue').add(arrayFiles);
							me.gridQueue.setVisible(true);
							me.selectedQueue.changed = true;
						} else {
							me.lblNowPlayed.setText(_("Active Queue is empty."));
							me.lblNowPlayed.setVisible(true);
						}
						me.nowFileType = 1;
						waitDialog.hide();
					}
				}
			};
			fChangedCallback.push(this.getDeviceQueueCallback);
		}
		
		if (selectedRoom > -1) {
			var waitDialog = new Ext.LoadMask(Ext.getBody(), {
				msg : _('Please wait, reading from Sonos device ...')
			});
			waitDialog.show();
			dss.raiseEvent('sonos.info', {
				actions : 'getCurrentQueue',
				zoneID : selectedRoom
			});
		}
	},
	constructGridLvlNowPlaying : function(fFromSetValue) {
		try {
			var me = this;
			this.selectedSong = null;
			this.selectedQueue = null;

			this.lblNowPlayed = Ext.create('Ext.form.Label', {
				text : "",
				margin : '0 0 2 20',
				cls : 'x-form-item-label',
				id : 'lblNowPlayed'
			});
			this.lblNowPlayed.setVisible(false);

			this.gridQueue = Ext.create('Ext.grid.Panel', {
				hideHeaders : true,
				autoScroll : true,
				width : 400,
				height : 230,
				margin : '5 0 0 20',
				store : Ext.data.StoreManager.lookup('whattoplay_queue'),
				viewConfig : {
					stripeRows : true
				},
				selModel : {
					mode : 'NONE'
				},
				columns : [ {
					sortable : false,
					hideable : false,
					flex : 1,
					renderer : this.defMacGridRenderer
				} ]
			});

			this.gridQueue.setVisible(false);
			this.gridQueue.on('itemclick', function(grid, record) {
				this.getSelectionModel().deselect(record);
			});
			this.gridQueue.setHeight(230);

			this.btnGet = Ext.create('Ext.Button', {
				text : _('Get song'),
				margin : '0 0 2 20',
				handler : function() {
					var selectedRoom = me.dssEditor.editControls.triggers.selectedRoomID;
					if (selectedRoom > -1)
						me.getSonosDeviceMusic(selectedRoom);
					else
						Ext.MessageBox.alert(_('Info'), _("Please first select room on trigger tab, to get current Sonos song"), null);
				}
			});
			this.btnQueue = Ext.create('Ext.Button', {
				text : _('Get Active queue'),
				margin : '0 0 2 20',
				handler : function() {
					var selectedRoom = me.dssEditor.editControls.triggers.selectedRoomID;
					if (selectedRoom > -1)
						me.getSonosDeviceQueue(selectedRoom);
					else
						Ext.MessageBox.alert(_('Info'), _("Please first select room on trigger tab, to get current Sonos Queue"), null);
				}
			});
			if (fFromSetValue != null)
				if (fFromSetValue) {
					this.btnGet.setDisabled(true);
					this.btnQueue.setDisabled(true);
				}
			var allButtons = Ext.create('Ext.container.Container', {
				defaultType : 'numberfield',
				items : [ this.btnGet, this.btnQueue ],
				layout : {
					type : 'hbox'
				},
				margin : '5 0 5 0',
				width : 600
			});

			this.grids.lvlNowPlaying = Ext.create('Ext.container.Container', {
				defaultType : 'numberfield',
				items : [ allButtons, me.lblNowPlayed, me.gridQueue ],
				layout : {
					type : 'vbox'
				},
				margin : '5 0 5 0',
				width : 440
			});

			this.macPanel.add(this.grids.lvlNowPlaying);

		} catch (e) {
			// alert("WtP initCache "+e.message);
		}
	},
	constructGridLvlPlaylist : function() {
		this.grids.lvlPlaylist = Ext.create('Ext.grid.Panel', {
			hideHeaders : true,
			height : this.iDefaultHeight,
			width : 624,
			autoScroll : true,
			viewConfig : {
				stripeRows : true
			},
			selModel : {
				mode : 'SINGLE'
			},
			store : Ext.data.StoreManager.lookup('whattoplay_playlists'),
			columns : [ {
				sortable : false,
				hideable : false,
				dataIndex : 'name',
				flex : 1,
				renderer : this.defMacGridRenderer
			} ]
		});

		this.grids.lvlPlaylist.parent = this;

		this.grids.lvlPlaylist.on('itemclick', function(grid, record) {
			if (record.get('_id') == -1) {
				this.getSelectionModel().deselect(record);
			} else {
				this.parent.updatePresetName(record.get('name'));
			}
		});

		this.macPanel.add(this.grids.lvlPlaylist);

	},
	constructGridLvlFavorites : function() {

		this.grids.lvlFavorites = Ext.create('Ext.grid.Panel', {
			hideHeaders : true,
			height : this.iDefaultHeight,
			width : 624,
			autoScroll : true,
			viewConfig : {
				stripeRows : true
			},
			selModel : {
				mode : 'SINGLE'
			},
			store : Ext.data.StoreManager.lookup('whattoplay_favorites'),
			columns : [ {
				sortable : false,
				hideable : false,
				dataIndex : 'name',
				flex : 1,
				renderer : this.defMacGridRenderer
			} ]
		});

		this.grids.lvlFavorites.parent = this;

		this.grids.lvlFavorites.on('itemclick', function(grid, record) {
			if (record.get('_id') == -1) {
				this.getSelectionModel().deselect(record);
			} else {
				this.parent.updatePresetName(record.get('name'));
			}
		});

		this.macPanel.add(this.grids.lvlFavorites);
	},
	constructMacGrids : function() {

		var me = this;

		if (this.grids.lvl1 != null)
			this.clearGridLevels([ 'lvl1' ]);
		else {
			this.grids.lvl1 = Ext.create('Ext.grid.Panel', {
				hideHeaders : true,
				height : this.iDefaultHeight,
				width : this.iDefaultWidth,
				autoScroll : true,
				viewConfig : {
					stripeRows : true
				},
				selModel : {
					mode : 'SINGLE'
				},
				store : Ext.data.StoreManager.lookup('presetAction_lvl1'),
				columns : [ {
					sortable : false,
					hideable : false,
					dataIndex : 'name',
					flex : 1,
					renderer : this.defMacGridRenderer
				} ]
			});
			this.grids.lvl1.getSelectionModel().store = this.grids.lvl1.store;
			this.grids.lvl1.parent = this;

			this.grids.lvl1.on('itemclick', function(grid, record) {
				this.parent.clearGridLevels([ 'lvl1' ]);
				this.parent.nowFileType = -1;

				var fIsPassive = false;
				if (record.get('passive') != null) {
					if (record.get('passive') == true) {
						this.getSelectionModel().deselect(record);
						fIsPassive = true;
					}
				}

				if (!fIsPassive) {
					if (record.get('_id') == 0) { // nowPlaying
						this.parent.constructGridLvlNowPlaying();
						this.getSelectionModel().deselectAll();
						this.getSelectionModel().select(record);
					} else if (record.get('_id') == 1) { // playlist
						this.parent.constructGridLvlPlaylist();
						this.getSelectionModel().deselectAll();
						this.getSelectionModel().select(record);
					} else if (record.get('_id') == 2) { // favorites
						this.parent.constructGridLvlFavorites();
						this.getSelectionModel().deselectAll();
						this.getSelectionModel().select(record);
					}
					this.parent.nActionType = record.get('_id');
				}
			});
		}

		if (!this.macPanel.contains(this.grids.lvl1, true))
			this.macPanel.add(this.grids.lvl1);

	},
	constructor : function(config) {
		this.iDefaultHeight = 290;

		this.macPanel = Ext.create('Ext.panel.Panel', {
			border : '0',
			autoScroll : true,
			height : this.iDefaultHeight + 2,
			layout : {
				type : 'hbox'
			},
			items : [],// this.grids.lvl1
			scroll : 'horizontal'
		});

		var me = this;
		this.checkVolume = Ext.create('Ext.form.field.Checkbox', {
			fieldLabel : "",
			align : 'middle',
			listeners : {
				'change' : function(checkbox, newVal, oldVal) {
					me.intVolume.setDisabled(!newVal);
				}
			}
		});

		var lblSetVolume = Ext.create('Ext.form.Label', {
			text : _("Set volume to"),
			align : 'middle',
			cls : 'x-form-item-label',
			margin : '0 0 0 10'
		});

		this.intVolume = Ext.create('Ext.form.field.Number', {
			fieldLabel : "",
			margin : '0 0 0 10',
			width : 50,
			step : 1,
			value : 0,
			minValue : 0,
			maxValue : 100
		});

		var lblSetVolume2 = Ext.create('Ext.form.Label', {
			text : "%",
			align : 'middle',
			cls : 'x-form-item-label',
			margin : '0 0 0 2'
		});

		this.rowVolume = Ext.create('Ext.container.Container', {
			defaultType : 'numberfield',
			items : [ this.checkVolume, lblSetVolume, this.intVolume, lblSetVolume2 ],
			layout : 'column',
			margin : '5 0 5 10',
			width : 650
		});

		var oTabPanelL = Ext.create('Ext.panel.Panel', {
			border : false,
			defaults : {
				style : {
					float : 'left'
				}
			},
			items : [ this.rowVolume ],
			width : 640
		});
		this.grids.pnlExtraFields = Ext.create('Ext.container.Container', {
			defaultType : 'numberfield',
			items : [ oTabPanelL ],
			layout : 'column',
			margin : '5 0 5 0',
			width : 760
		});

		Ext.apply(this, {
			items : [ this.macPanel, this.grids.pnlExtraFields ]
		});

		this.callParent(arguments);
	},
	clearGridLevels : function(idsNotToRemove) {
		if (idsNotToRemove == null)
			idsNotToRemove = [];
		for ( var sKey in this.grids)
			if (idsNotToRemove.indexOf(sKey) < 0)
				this.macPanel.remove(this.grids[sKey]);
	},
	reset : function() {
		try {
			me = this;
			this.nowFileType = -1;

			this.initLvl1();
			this.constructMacGrids();
			this.initStores();

			this.checkVolume.setValue(false);
			this.intVolume.setValue(0);
			this.grids.lvl1.getSelectionModel().deselectAll();

		} catch (e) {
			// alert("WtP reset "+e.message);
		}
	},
	setValue : function(values) {
		try {
			this.initLvl1();
			this.constructMacGrids();
			this.initStores();

			if (values.volume != null) {
				this.checkVolume.setValue(true);
				this.intVolume.setValue(values.volume);
			} else {
				this.checkVolume.setValue(false);
				this.intVolume.setValue(0);
			}

			switch (values.type) {

			case 'playlist':
				var oRecord = this.grids.lvl1.store.find('_id', 1, false, false, true);
				this.grids.lvl1.getSelectionModel().select(oRecord, true);
				this.constructGridLvlPlaylist();
				var oRecordPlaylist = Ext.data.StoreManager.lookup('whattoplay_playlists').find('listUrl', values.contentSrc, 0, false, false, true);
				if (oRecordPlaylist != -1) {
					this.grids.lvlPlaylist.getSelectionModel().select(oRecordPlaylist);
				}
				break;
			case 'favorite':
				var oRecord = this.grids.lvl1.store.find('_id', 2, false, false, true);
				this.grids.lvl1.getSelectionModel().select(oRecord, true);
				this.constructGridLvlFavorites();
				var oRecordFavorites = Ext.data.StoreManager.lookup('whattoplay_favorites').find('listUrl', values.contentSrc, 0, false, false, true);
				if (oRecordFavorites != -1) {
					this.grids.lvlFavorites.getSelectionModel().select(oRecordFavorites);
				}
				break;
			case 'plainSong':
				var oRecord = this.grids.lvl1.store.find('_id', 0, false, false, true);
				this.grids.lvl1.getSelectionModel().select(oRecord, true);
				this.constructGridLvlNowPlaying(true);
				this.macPanel.add(this.grids.lvlNowPlaying);
				this.lblNowPlayed.setVisible(true);

				this.selectedSong = {
					isRadio : false,
					title : values.info.title,
					url : values.contentSrc
				};
				if (values.info.artist != null)
					this.selectedSong.artist = values.info.artist;
				if (values.metaData != null)
					this.selectedSong.Metadata = values.metaData;

				var sTitle = _("Song: ");
				if (this.selectedSong.title != null)
					if (this.selectedSong.title != "")
						sTitle += this.selectedSong.title;
				if (this.selectedSong.artist != null)
					if (this.selectedSong.artist != "")
						sTitle += " (" + this.selectedSong.artist + ")";
				this.lblNowPlayed.setText(sTitle);

				this.gridQueue.setVisible(false);
				this.selectedQueue = null;
				this.handleRepeatPreviusMusicControl();

				break;
			case 'plainRadio':
				var oRecord = this.grids.lvl1.store.find('_id', 0, false, false, true);
				this.grids.lvl1.getSelectionModel().select(oRecord, true);
				this.constructGridLvlNowPlaying(true);
				this.macPanel.add(this.grids.lvlNowPlaying);
				this.lblNowPlayed.setVisible(true);
				this.selectedSong = {
					isRadio : true,
					title : values.info.title,
					url : values.contentSrc
				};
				if (values.info.artist != null)
					this.selectedSong.artist = values.info.artist;
				if (values.metaData != null)
					this.selectedSong.Metadata = values.metaData;

				var sTitle = _("Radio: ");
				if (this.selectedSong.title != null)
					if (this.selectedSong.title != "")
						sTitle += this.selectedSong.title;
				if (this.selectedSong.artist != null)
					if (this.selectedSong.artist != "")
						sTitle += " (" + this.selectedSong.artist + ")";
				this.lblNowPlayed.setText(sTitle);
				this.nowFileType = 0;
				this.gridQueue.setVisible(false);
				this.selectedQueue = null;
				break;
			case 'plainQueue':
				var oRecord = this.grids.lvl1.store.find('_id', 0, false, false, true);
				this.grids.lvl1.getSelectionModel().select(oRecord, true);
				this.constructGridLvlNowPlaying(true);
				this.macPanel.add(this.grids.lvlNowPlaying);
				this.lblNowPlayed.setVisible(false);
				this.lblNowPlayed.setText("");
				this.selectedSong = null;
				this.gridQueue.setVisible(true);
				this.selectedQueue = [];
				for ( var sKey in values.queue) {
					this.selectedQueue.push({
						playID : values.queue[sKey].contentSrc,
						title : values.queue[sKey].title,
						trackPos : values.queue[sKey].pos
					});
				}

				if (this.selectedQueue.length > 0) {
					var arrayFiles = new Array();
					for (var iIndex = 0; iIndex < this.selectedQueue.length; iIndex++) {
						var pos = (iIndex + 1);
						var tmpObj = new Object({
							_id : iIndex,
							name : pos + ". " + unescape(this.selectedQueue[iIndex].title)
						});
						arrayFiles.push(tmpObj);
					}
					Ext.data.StoreManager.lookup('whattoplay_queue').add(arrayFiles);
					this.gridQueue.setVisible(true);
					this.selectedQueue.changed = true;
				} else {
					this.lblNowPlayed.setText(_("Active Queue is empty."));
					this.lblNowPlayed.setVisible(true);
				}
				this.nowFileType = 1;

				break;
			}

		} catch (e) {
			// alert("WtP setValue "+e.message);
		}
	},
	isValid : function() {
		var bValid = true;
		var bCheckFileLength = true;

		var oSelectionLVL1 = this.grids.lvl1.getSelectionModel().getSelection()[0];

		if (this.checkVolume.getValue()) {
			if (!this.intVolume.isValid())
			{
				Ext.MessageBox.alert(_('Info'), _("Invalid volume value!"), null);
				return false;
			}
		}

		
		switch (oSelectionLVL1.get('_id')) { // media library
		case 0:
			if (this.selectedSong != null)
				return true;
			if (this.selectedQueue != null)
				if (this.selectedQueue.length > 0)
					return true;
			return false;
			break;
		case 1:
			var oSelectionPlaylist = this.grids.lvlPlaylist.getSelectionModel().getSelection();
			return (oSelectionPlaylist.length == 1);
			break;
		case 2:
			var oSelectionFavorites = this.grids.lvlFavorites.getSelectionModel().getSelection();
			return (oSelectionFavorites.length == 1);
			break;

		}

		return false;


	},
	getValue : function() {
		var returnValue = {};
		try {
			var oSelectionLVL1 = this.grids.lvl1.getSelectionModel().getSelection()[0];
			switch (this.grids.lvl1.getSelectionModel().getSelection()[0].get('_id')) {
			case 0:
				if (this.nowFileType == 0) {
					if (this.selectedSong.isRadio)
						returnValue.type = 'plainRadio';
					else
						returnValue.type = 'plainSong';

					returnValue.contentSrc = this.selectedSong.url;
					returnValue.info = {};
					if (this.selectedSong.title != null)
						if (this.selectedSong.title != "")
							returnValue.info.title = this.selectedSong.title;
					if (this.selectedSong.artist != null)
						if (this.selectedSong.artist != "")
							returnValue.info.artist = me.selectedSong.artist;
					if (this.selectedSong.Metadata != null)
						if (this.selectedSong.Metadata != "")
							returnValue.metaData = me.selectedSong.Metadata;
				} else {
					returnValue.type = 'plainQueue';
					returnValue.content = [];
					for (var iIndex = 0; iIndex < this.selectedQueue.length; iIndex++) {
						returnValue.content.push({
							contentUrl : this.selectedQueue[iIndex].playID,
							title : this.selectedQueue[iIndex].title,
							pos : this.selectedQueue[iIndex].trackPos
						});
					}
				}
				break;
			case 1:
				var oSelectionPlaylist = this.grids.lvlPlaylist.getSelectionModel().getSelection();
				returnValue.type = 'playlist';
				returnValue.contentSrc = oSelectionPlaylist[0].get('listUrl');
				break;
			case 2:
				var oSelectionFavorites = this.grids.lvlFavorites.getSelectionModel().getSelection();
				returnValue.type = 'favorite';
				returnValue.contentSrc = oSelectionFavorites[0].get('listUrl');
				returnValue.metaData = escape(oSelectionFavorites[0].get('metaData'));
				break;
			}

			if (this.checkVolume.getValue())
				returnValue.volume = this.intVolume.getValue();

		} catch (e) {
			// alert("WtP getValue "+e.message);
		}

		return returnValue;
	}
});
