Ext
		.define(
				'DSS.addon.SelectRooms',
				{
					extend : 'DSS.component.Base',
					mixins : {
						observable : 'Ext.util.Observable'
					},
					getHeight : function() {
						return 20;
					},
					nSelectedAction : -1,
					actionRoomsPanel : null,
					actionRoomsPanelMulti : null,
					actionTypeAll : null,
					lblActionRooms : null,
					rowExecRooms : null,
					checkGrouping : null,
					gridRooms : null,
					roomRenderer : function(val, metadata, record, colIdx, store, view) {
						var sPassive = "";
						if (record.get('passive') != null && record.get('passive'))
							sPassive = 'style="color:#888888;"';
						var sReturn = '<table style="height:16px;"><tr>';
						sReturn += '<td ' + sPassive + ' width="100%">' + record.get('roomName') + '</td>';
						return sReturn + '</tr></table>';
					},
					isGroupingAllowed : function(bShowAlert, bResetValue) {
						var bIsOK = true;
						if (this.checkGrouping.checked) {
							return true;
							var isSelectedSingleFile = false;
							switch (this.dssEditor.editControls.action.nActionType) {
							case 0: // now playing
								if (this.dssEditor.editControls.action.nowFileType == 0) {// single
									// song/radio
									isSelectedSingleFile = !this.dssEditor.editControls.action.bIsRadio;
								}
								break;

							case 2: // favorites
								var oSelectionFavorites = this.dssEditor.editControls.action.grids["activity"].lvlFavorites.getSelectionModel().getSelection();
								if (oSelectionFavorites != null && oSelectionFavorites.length > 0)
									isSelectedSingleFile = oSelectionFavorites[0].get('isSingleTrack');
								break;

							case 3: // media lib
							case 4: // text2speech
							case 5: // command
								isSelectedSingleFile = true;
								break;
							}

							if (!isSelectedSingleFile && !this.dssEditor.editControls.action.checkRepeat.checked) {
								if (bShowAlert)
									Ext.MessageBox.alert(_('Info'), _("Uknown activity execution length. Sonos grouping is not allowed!"), null);

								if (bResetValue) {
									this.suspendEvents(false);
									this.setValue(false);
									this.resumeEvents();
								}
								bIsOK = false;
							}
						}
						return bIsOK;
					},
					constructor : function(config) {
						var me = this;
						this.lblActionRooms = Ext.create('Ext.form.Label', {
							text : _("Play music in:"),
							align : 'middle',
							cls : 'x-form-item-label',
							margin : '0 0 0 0'
						});

						this.actionTypeAll = Ext.create('Ext.form.RadioGroup', {
							fieldLabel : _(''),
							labelWidth : 340,
							items : [ {
								inputValue : 0,
								boxLabel : _('All rooms'),
								name : 'roomType'
							} ],
							columns : 1,
							columnWidth : 400,
							width : 400,
							padding : '0 0 2 0',
							listeners : {
								change : function(radiogroup, radio) {
									if (radio.roomType != null) {
										me.nSelectedAction = 0;
										me.gridRooms.disable();
										me.gridRooms.getSelectionModel().deselectAll();
									}
								}
							}
						});

						this.actionTypeMulti = Ext.create('Ext.form.RadioGroup', {
							fieldLabel : _(''),
							labelWidth : 340,
							items : [ {
								inputValue : 1,
								boxLabel : _('Selected rooms'),
								name : 'roomType'
							} ],
							columns : 1,
							columnWidth : 400,
							width : 400,
							padding : '0 0 4 0',
							listeners : {
								change : function(radiogroup, radio) {
									if (radio.roomType != null) {
										me.nSelectedAction = 1;
										me.gridRooms.enable();
										me.gridRooms.getSelectionModel().deselectAll();
									}
								}
							}
						});

						this.gridRooms = Ext.create('Ext.grid.Panel', {
							hideHeaders : true,
							autoScroll : true,
							width : 300,
							height : 220,
							margin : '0 0 0 20',
							viewConfig : {
								stripeRows : true
							},
							selModel : {
								mode : 'MULTI'
							},
							columns : [ {
								sortable : false,
								hideable : false,
								dataIndex : 'roomID',
								flex : 1,
								renderer : this.roomRenderer
							} ]
						});

						this.actionRoomsPanel = Ext.create('Ext.container.Container', {
							defaultType : 'numberfield',
							items : [ this.actionTypeAll, this.actionTypeMulti, this.gridRooms ],
							layout : {
								type : 'vbox'
							},
							margin : '0 0 0 10',
							width : 400
						});

						this.rowExecRooms = Ext.create('Ext.container.Container', {
							defaultType : 'numberfield',
							items : [ this.lblActionRooms, this.actionRoomsPanel ],
							layout : 'column',
							margin : '0 0 0 10',
							width : 530
						});

						this.checkGrouping = Ext.create('Ext.form.field.Checkbox', {
							fieldLabel : "",
							align : 'left',
							listeners : {
								'change' : function(checkbox, newVal, oldVal) {
									me.isGroupingAllowed(true, true);
								}
							}
						});

						var lblGrouping = Ext.create('Ext.form.Label', {
							text : _("Group all players, if more than one (For testing only)"),
							align : 'middle',
							cls : 'x-form-item-label',
							margin : '0 0 0 10'
						});

						var rowGrouping = Ext.create('Ext.container.Container', {
							defaultType : 'numberfield',
							items : [ this.checkGrouping, lblGrouping ],
							layout : 'column',
							margin : '5 0 5 10',
							width : 730
						});

						var lblGroupingInfo = Ext
								.create(
										'Ext.form.Label',
										{
											text : _("Notice: In combination with 'Restart previous music once finished' each player joined to group is introducing at least half a second delay in sound reproduction for target group."),
											align : 'middle',
											cls : 'x-form-item-label',
											margin : '0 0 0 35',
											width : 730
										});

						Ext.apply(this, {
							items : [ this.rowExecRooms, rowGrouping, lblGroupingInfo ]
						// 
						});
						this.callParent(arguments);
					},
					reset : function() {
						try {
							this.gridRooms.reconfigure(Ext.data.StoreManager.lookup('whattoselect_rooms'));
							this.actionTypeAll.setValue({
								'roomType' : 0
							});
							this.gridRooms.disable();
							this.gridRooms.getSelectionModel().deselectAll();
							this.checkGrouping.suspendEvents(false);
							this.checkGrouping.setValue(false);
							this.checkGrouping.resumeEvents();

						} catch (e) {
							// alert("SelectRooms reset "+e.message);
						}
					},
					setValue : function(value) {
						try {
							this.gridRooms.reconfigure(Ext.data.StoreManager.lookup('whattoselect_rooms'));
							this.gridRooms.getSelectionModel().deselectAll();
							this.checkGrouping.suspendEvents(false);
							this.checkGrouping.setValue(value.grouped!=null);
							this.checkGrouping.resumeEvents();
							var oZones=null;
							if (value.grouped)
								oZones=value.grouped;
							else
								oZones=value.singularyZone;
							for (var iIndex=0;iIndex<oZones.length;iIndex++) {
								if (oZones[iIndex]==0) {
									this.actionTypeAll.setValue({
										'roomType' : 0
									});
									this.gridRooms.disable();
									return;
								} else {
									this.actionTypeAll.setValue({
										'roomType' : 1
									});
									this.gridRooms.enable();
									for (var iIndex=0;iIndex<oZones.length;iIndex++) {
										var zoneID=oZones[iIndex];
										
										var oRecord=this.gridRooms.store.find('roomID', zoneID,0,false,false,true);
										if (oRecord!=-1)
											this.gridRooms.getSelectionModel().select(oRecord,true);
									}
								}
									
							}
							
						} catch (e) {
							// alert("SelectRooms setValue"+e.message);
						}
					},
					isValid : function() {
						var bValid = false;
						if (this.nSelectedAction == 0)
							bValid = true;
						else if (this.nSelectedAction == 1)
							bValid = (this.gridRooms.getSelectionModel().getSelection().length > 0);

						var bGroupingAllowed = this.isGroupingAllowed(false, false);
						if (bValid && !bGroupingAllowed) {
							bValid = false;
						}

						return bValid;
					},
					getValue : function() {
						var returnValue = {};
						var oRoomArray = [];
						if (this.nSelectedAction == 1) { // selected rooms
							var oSelectionRooms = this.gridRooms.getSelectionModel().getSelection();
							if (oSelectionRooms.length > 0) {
								for (var iIndex = 0; iIndex < oSelectionRooms.length; iIndex++) {
									oRoomArray.push(parseInt("" + oSelectionRooms[iIndex].get('roomID'), 10));
								}
							}
						} else
							oRoomArray.push(0)

						if (this.checkGrouping.checked) {
							returnValue.grouped = oRoomArray;
						} else {
							returnValue.singularyZone = oRoomArray;
						}
						return returnValue;
					}
				});
